﻿<ComClass("1659EA76-4EC7-4ec4-941F-F476169D74A6")> _
Public Class Control

    Private m_ClickCount As Integer = 0
    Private m_inventorApp As Inventor.Application
    Private WithEvents appEvents As Inventor.ApplicationEvents
    Private m_currentDoc As Inventor.PartDocument

    Private Sub Control_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Public Property InventorApplication() As Inventor.Application
        Get
            Return m_inventorApp
        End Get
        Set(ByVal value As Inventor.Application)
            m_inventorApp = value
            appEvents = m_inventorApp.ApplicationEvents

            If m_inventorApp.ActiveEditDocument.DocumentType = Inventor.DocumentTypeEnum.kPartDocumentObject Then
                m_currentDoc = m_inventorApp.ActiveEditDocument
                UpdateDocumentInfo()
            Else
                m_currentDoc = Nothing
                UpdateDocumentInfo()
            End If
        End Set
    End Property

    Private Sub UpdateDocumentInfo()
        If m_currentDoc Is Nothing Then
            Me.lblFeatureCount.Text = "Features: "
            Me.lblVolume.Text = "Volume: "
            Me.lblFeatureCount.ForeColor = Color.Gray
            Me.lblVolume.ForeColor = Color.Gray
        Else
            Me.lblFeatureCount.ForeColor = Color.Black
            Me.lblVolume.ForeColor = Color.Black

            Me.lblFeatureCount.Text = "Features: " & m_currentDoc.ComponentDefinition.Features.Count
            Dim lengthSymbol As String = m_currentDoc.UnitsOfMeasure.GetStringFromType(m_currentDoc.UnitsOfMeasure.LengthUnits)
            Me.lblVolume.Text = "Volume: " & m_currentDoc.UnitsOfMeasure.GetStringFromValue(m_currentDoc.ComponentDefinition.MassProperties.Volume, lengthSymbol & "^3")
        End If
    End Sub

    Private Sub appEvents_OnDocumentChange(ByVal DocumentObject As Inventor._Document, ByVal BeforeOrAfter As Inventor.EventTimingEnum, ByVal ReasonsForChange As Inventor.CommandTypesEnum, ByVal Context As Inventor.NameValueMap, ByRef HandlingCode As Inventor.HandlingCodeEnum) Handles appEvents.OnDocumentChange
        If Not m_currentDoc Is Nothing Then
            UpdateDocumentInfo()
        End If
    End Sub

    Private Sub appEvents_OnNewEditObject(ByVal EditObject As Object, ByVal BeforeOrAfter As Inventor.EventTimingEnum, ByVal Context As Inventor.NameValueMap, ByRef HandlingCode As Inventor.HandlingCodeEnum) Handles appEvents.OnNewEditObject
        If m_inventorApp.ActiveEditDocument.DocumentType = Inventor.DocumentTypeEnum.kPartDocumentObject Then
            If Not m_inventorApp.ActiveEditDocument Is m_currentDoc Then
                m_currentDoc = m_inventorApp.ActiveEditDocument
                UpdateDocumentInfo()
            End If
        Else
            m_currentDoc = Nothing
            UpdateDocumentInfo()
        End If
    End Sub
End Class
